;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
;END_HEADER

                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab1.inc"             ;Lab-specific global equates

;Provide global scope to the Interrupt Service Routines
;NOTE: This ensures that the linker will load the ISR addresses
; in to the main Interupt Vector Table (IVT)

        .global __INT1Interrupt
        .global __INT2Interrupt
		.global __INT3Interrupt			; Added !!
		.global	__INT4Interrupt			; Added !!

        ; INSERT PART 1 CODE HERE       ;Provide global scope to INT3 and INT4
        ; INSERT PART 1 CODE HERE       ;Interrupt Service Routines

        .section .text                  ;Places source code in Code section

; Interrupt Service Routine for INT1
; INSERT PART 1 CODE HERE               ;Define interrupt label for INT1
                                        ;using labels provided in the device
                                        ;linker script

__INT1Interrupt:						; Added !!

        btg     LATD, #LATD0            ;Toggle LATD bit LATD0

testS1: btss    PORTA, #RA12            ;Wait in Interrupt until a rising
        bra     testS1                  ;edge occurs on the INT1 pin

        ; INSERT PART 1 CODE HERE       ;Clear the interrupt flag status bit
                                        ;in the IFS1 SFR
		bclr    IFS1, #INT1IF			; Added !!

        ; INSERT PART 1 CODE HERE       ;Return from Interrupt

		retfie							; Added !!


; Interrupt Service Routine for INT2
; INSERT PART 1 CODE HERE               ;Define interrupt label for INT2
                                        ;using labels provided in the device
                                        ;linker script
__INT2Interrupt:						; Added !!

        btg     LATD, #LATD1            ;Toggle LATD bit LATD1

testS2: btss    PORTA, #RA13            ;Wait in Interrupt until a rising
        bra     testS2                  ;edge occurs on the INT2 pin

        ; INSERT PART 1 CODE HERE       ;Clear the interrupt flag status bit
                                        ;in the IFS1 SFR
		bclr    IFS1, #INT2IF

        ; INSERT PART 1 CODE HERE       ;Return from Interrupt
		retfie							; Added !!


; Interrupt Service Routine for INT3
; INSERT PART 1 CODE HERE               ;Define interrupt label for INT3
                                        ;using labels provided in the device
                                        ;linker script
__INT3Interrupt:						; Added !!

        btg     LATD, #LATD2            ;Toggle LATD bit LATD2

testS3: btss    PORTA, #RA14            ;Wait in Interrupt until a rising
        bra     testS3                  ;edge occurs on the INT3 pin

        ; INSERT PART 1 CODE HERE       ;Clear the interrupt flag status bit
                                        ;in the IFS2 SFR

		bclr    IFS2, #INT3IF			; Added !!

        ; INSERT PART 1 CODE HERE       ;Return from Interrupt
		
		retfie							; Added !!

; Interrupt Service Routine for INT4
; INSERT PART 1 CODE HERE               ;Define interrupt label for INT4
                                        ;using labels provided in the device
                                        ;linker script
__INT4Interrupt:						; Added !!

        btg     LATD, #LATD3            ;Toggle LATD bit LATD3

testS4: btss    PORTA, #RA15            ;Wait in Interrupt until a rising
        bra     testS4                  ;edge occurs on the INT4 pin

        ; INSERT PART 1 CODE HERE       ;Clear the interrupt flag status bit
                                        ;in the IFS2 SFR
		bclr    IFS2, #INT4IF			; Added !!

        ; INSERT PART 1 CODE HERE       ;Return from Interrupt
		
		retfie 							; Added !!



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.end                                    ;EOF
