;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"        ;Device specific SFR bit definitions
        .include "lab1.inc"             ;Lab-specific global equates

        .global _INTx_pin_init          ;Provide global scope to routine
        .section .text                  ;Places source code in Code section

_INTx_pin_init:

        bset    INTCON2, #INT4EP        ;Set up INT1-INT4 pins to detect a
        bset    INTCON2, #INT3EP        ;falling edge on the pins
        bset    INTCON2, #INT2EP
        bset    INTCON2, #INT1EP


;INT1-INT4 pin interrupt priority control (IPC) bits set to their
;default states on power-up as follows:
;       Interrupt Priority for INT1 = 4
;       Interrupt Priority for INT2 = 4
;       Interrupt Priority for INT3 = 4
;       Interrupt Priority for INT4 = 4
;There is a natural order inetrrupt priority for peripherals that is used by
;the CPU to resolve conflicts when interrupt sources having identical interrupt
;priorities, interrupt the CPU simultaneously. The relative Natural Order
;Priority for the INTx pins is as follows:
;Priority for INT1 > Priority for INT2 > Priority for INT3 > Priority for INT4
;We will use these defaults for Lab1 Part1.


;Clear INT1-INT4 pin interrupt flag status bits to bring them to a known state
        bclr    IFS1, #INT1IF           ;Clear the INT1IF bit in the IFS1
                                        ;register
		bclr	IFS1, #INT2IF 			; Added !!
		bclr	IFS2, #INT3IF			; Added !!
		bclr	IFS2, #INT4IF			; Added !!
        ; INSERT PART 1 CODE HERE       ;Clear the INT2IF bit
        ; INSERT PART 1 CODE HERE       ;Clear the INT3IF bit
        ; INSERT PART 1 CODE HERE       ;Clear the INT4IF bit


;Enable Interrupt Service Routine Processing for INT1-INT4 pins
        bset    IEC1, #INT1IE           ;Set the INT1IE bit in the IEC1 register
		bset	IEC1, #INT2IE			; Added !!
		bset	IEC2, #INT3IE			; Added !!
		bset	IEC2, #INT4IE			; Added !!
        ; INSERT PART 1 CODE HERE       ;Set the INT2IE bit
        ; INSERT PART 1 CODE HERE       ;Set the INT3IE bit
        ; INSERT PART 1 CODE HERE       ;Set the INT4IE bit

        return                          ;Return to calling routine



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.end                                    ;EOF

