;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
; File Notes:
; 1. This file contains the "_main" routine. The run-time start-up library
;    will bring code execution to the label "_main" after initializing
;    data RAM.
; 2. All sub-routines are called from this file.
;
;
; LAB1 - Part 1 Instructions:
; 1. Set LAB1_PART1 equate to "1". (located in Lab1.inc file)
; 2. Fill in the missing source code in the "_port_pins_init" routine.
;    Refer to port_pins_init.s file in project window.
; 2. Fill in the missing source code in the "_INTx_pin_init" routine.
;    Refer to INTx_pin_init.s file in project window.
; 3. Fill in the missing source code in the interrupt service routines -
;    named "__INT?Interrupt". Refer to INTxInterrupt.s file in project
;    window.
;
;
; LAB1 - Part 2 Instructions:
; 1. Set LAB1_PART1 equate to "1". (located in Lab1.inc file)
; 2. Set LAB1_PART2 equate to "1". (located in Lab1.inc file)
; 3. Fill in code for Lab 1 - Part 2 in this main.s file. Again, build and
;    program the device.
;
;
; LAB1 - Part 3 Instructions:
; 1. Insert "AltINTxInterrupt.s" file into the MPLAB project.
; 2. Fill in the missing source code in the interrupt service routines -
;    "__AltINT?Interrupt". Refer to AltINTxInterrupt.s file in project window.
; 3. Set LAB1_PART1 equate to "1". (located in Lab1.inc file)
; 4. Clear LAB1_PART2 equate to "0". (located in Lab1.inc file)
; 4. Set LAB1_PART3 equate to "1". (located in Lab1.inc file)
; 5. Fill in code for Lab1 - Part 3 in this main.s file. Again, build and
;    program the device.
;
;
; LAB1 - Part 4 Instructions:
; 1. Set LAB1_PART1 equate to "1". (located in Lab1.inc file)
; 2. Set LAB1_PART2 equate to "1". (located in Lab1.inc file)
; 3. Clear LAB1_PART3 equate to "0". (located in Lab1.inc file)
; 4. Set LAB1_PART4 equate to "1". (located in Lab1.inc file)
; 5. Fill in code for Lab1 - Part 4 in this main.s file. Again, build and
;    program the device.
;
;..............................................................................
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab1.inc"             ;Lab-specific global equates

        config __FOSC, CSW_FSCM_OFF & XT_PLL8
        config __FWDT, WDT_OFF
        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_OFF & MCLR_EN
        config __FGS, CODE_PROT_OFF

        .global _main                   ;Provide global scope to routine
        .section .text                  ;Places source code in Code section


_main:                                  ;C-run-time library brings you here


.if LAB1_PART1

        bclr    INTCON1, #NSTDIS        ;Ensure Interrupt-nesting is enabled


        rcall   _SPI2_init              ;Set up SPI2 for Communication
                                        ;with the LCD Controller

        rcall   _LCD_Controller_init    ;Initialize the LCD Controller and
                                        ;the LCD display

        rcall   _port_pins_init         ;"Relative" Call to the port pin
                                        ;initialization routine


        rcall   _INTx_pin_init          ;"Relative" Call to the INT1-INT4 pin
                                        ;initialization routine

.endif

.if LAB1_PART2

;Set up INT1-INT4 pin interrupt priority control (IPC) bits as follows:

        ;Set up INT1 pin Interrupt Priority in the IPC4 SFR
        ;Interrupt Priority for INT1 = 4
        bset    IPC4, #INT1IP2
        bclr    IPC4, #INT1IP1
        bclr    IPC4, #INT1IP0

        ;Set up INT2 pin Interrupt Priority in the IPC5 SFR
        ;Interrupt Priority for INT2 = 5
		bset	IPC5, #INT2IP2
		bclr	IPC5, #INT2IP1
		bset	IPC5, #INT2IP0
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE

        ;Set up INT3 pin Interrupt Priority in the IPC9 SFR
        ;Interrupt Priority for INT3 = 6
		bset	IPC9, #INT3IP2
		bset	IPC9, #INT3IP1
		bclr	IPC9, #INT3IP0
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE

        ;Set up INT4 pin Interrupt Priority in the IPC9 SFR
        ;Interrupt Priority for INT4 = 7
		bset	IPC9, #INT4IP2
		bset	IPC9, #INT4IP1
		bset	IPC9, #INT4IP0 
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE
        ; INSERT PART 2 CODE HERE

.endif

.if LAB1_PART3

        ;Enable processing of Alternate Interrupt Service Routines
        ; INSERT PART 3 CODE HERE
		bset    INTCON2, #ALTIVT		; Added !!

.endif


done:   nop

.if LAB1_PART4

        ;Disable Interrupts for 31 cycles
        ; INSERT PART 4 CODE HERE
		DISI	#30

.endif

        bra     done                    ;Loop endlessly to "done"




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.end                                    ;EOF
