;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
; File Notes:
; 1. This file contains the "_main" routine. The run-time C start-up library
;    will bring code execution to the label "_main" after initializing
;    data RAM.
; 2. All sub-routines are called from this file.
;
; LAB 2 Instructions:
; 1. Fill in the missing source code in the "lab2_part1.s" file.
; 2. Build the project, program the device and run
; 3. Vary the potentiometers - RP1, RP2 and RP3, feel the temp-
;    erature sensor on U9 and note the results on the LCD display.
; 4. Add the file, lab2_part2.s, into the MPLAB project.
; 5. Fill in the missing source code in the "lab2_part2.s" file.
; 6. Fill in the missing source code in this file so as to call
;    the subroutine (lab2_part2) in the "lab2_part2.s" file
; 7. Connect the fold-up speaker to J17-"SPKR OUT".
; 8. Build the project, program the device and run.
; 9. Vary RP1 and hear the changing tones on the speaker.
;10. Add the file, lab2_part3.s, into the MPLAB project.
;11. Fill in the missing source code in the "lab2_part3.s" file.
;12. Fill in the missing source code in this file so as to call
;    the subroutine (lab2_part3) in the "lab2_part3.s" file
;13. Build the project, program the device and run
;14. Connect J2-PortA on the board to the PC COM port and open
;    a Hyper Terminal session window operating in the 8-N-1
;    configuration at 57600 baud. Observe a display on the sesion window
;..............................................................................
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab2.inc"             ;Lab-specific global equates

                                        ;Config Macros to program configuration
                                        ;words
                                        ;More example macros are provided in
                                        ;the device include file, p30f6014.inc
        config __FOSC, CSW_FSCM_OFF & XT_PLL8
        config __FWDT, WDT_OFF
        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_OFF & MCLR_EN
        config __FGS, CODE_PROT_OFF

                                        ;Provide global definitions
        .global _main
        .global __AddressError, __StackError    ;Provide global scope to the
                                        ;Address and Stack Error Trap handlers
                                        ;The linker will place the address of
                                        ;the routines in the Interrupt Vector
                                        ;Table (IVT)

        .section .text                  ;Places source code in Code section
_main:                                  ;C-run-time start-up library brings you
                                        ;here after initializing RAM variables

        rcall   _SPI2_init              ;Call SPI2 initialization routine

        rcall   _LCD_Controller_init    ;Call the LCD Controller initialization
                                        ;routine

        rcall   lab2_part1              ;Call lab2_part1 subroutine

        ; INSERT PART 2 CODE HERE       ;Call lab2_part2 subroutine

		rcall	lab2_part2 				; Added !!

        ; INSERT PART 3 CODE HERE       ;Call lab2_part2 subroutine
		
		rcall	lab2_part3				; Added !!

main_loop:
        ; INSERT PART 3 CODE HERE       ;Call display_string subroutine
                                        ;to update HyperTerminal Session screen

		rcall	display_string			; Added !!

        rcall   _DisplayLCD             ;Call _DisplayLCD subroutine to
                                        ;update LCD display

        do      #4000, L1               ;Software Delay Loop of arbitrary
        repeat  #4000                   ;duration implemented via nested DO and
        nop                             ;REPEAT loops
        nop
L1:     nop

        bra     main_loop               ;Branch unconditionally to main_loop

;...
;Trap Handler Routines:
;1. Address Error Trap
;2. Stack Error Trap
;...

__AddressError:                         ;Address Error trap Routine
L2:     nop                             ;Code execution reaches here if
        bra     L2                      ;incorrect addresses are accessed
                                        ;in Data memory or Program memory
        bclr    INTCON1, #ADDRERR       ;Example clearing of the trap flag
        retfie                          ;Return from trap handler

__StackError:                           ;Stack Error trap Routine
L3:     nop                             ;Code execution reaches here if
        bra     L3                      ;a stack underflow or overflow occurred
        bclr    INTCON1, #STKERR        ;Example clearing of the trap flag
        retfie                          ;Return from trap handler


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        .end                                    ;EOF




