;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
; File Notes:
;
;END_HEADER

.include "p30f6014.inc"

.section .text
.global _ADC_init
_ADC_init:
        push w0

        bclr ADCON1, #ADON

;Set up auto-sampling and auto-conversion options
;Also, align the result buffer to provide fractional 1.15 (Q15) data
        mov #0x00E4 ,w0
        mov w0, ADCON1

;Set up conversions/interrupt options to 1 conversion per interrupt
         mov #0x0000 ,w0
         mov w0, ADCON2

;Set up TAD clock(in number of Tcy) and auto-sampling time
;(in number of TAD clock) for 8000 Samples/Second
;See Family Reference Manual for formula
         mov #0x0A0C ,w0
         mov w0, ADCON3

;Set up the channel(s) to convert -> AN6/RB6
         mov #0x0006 ,w0
         mov w0, ADCHS

;Ensure Port B pins are configured as analog inputs
         mov #0xFFBF, w0
         mov w0, ADPCFG

;Disable channel scanning
         mov #0x0000 ,w0
         mov w0, ADCSSL

;Set up interrupt priorities and enable interrupts
         bclr IFS0, #ADIF
         bclr IEC0, #ADIE
         mov.b #0b11100000, w0
         ior.b IPC2H


	bset 	ADCON1, #ADON		;Turn on A/D module
	

         pop w0
         return



         .end


