;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
; File Notes:
; 1. This file contains the "_main" routine. The run-time C start-up library
;    will bring code execution to the label "_main" after initializing
;    data RAM.
; 2. All sub-routines are called from this file.
;
; LAB 5 Part 1 Instructions:
; 1. Ensure LAB5_PART1 is equated to 1 and LAB5_PART2 is equated to 0 in
;    the Lab5.inc file in the project window.
;
; 2. Fill in the missing source code in the "_main" routine. Refer to
;    this main.s file in project window.
;
; 3. Fill in the missing source code in the subroutine -
;    named "_Copy_PM_String" for LAB5_PART1. Refer to Copy_PM_String.s file
;    in project window.
;
; 4. Program the device using ICD2. Reset and Run
;    You will see "Time and Tide" displayed on line 3 of the LCD
;
; 5. Press switch S1
;    What do you see on Line 3 of the LCD?
;
; LAB 5 Part 2 Instructions:
; 1. Ensure LAB5_PART1 is equated to 0 and LAB5_PART2 is equated to 1 in
;    the Lab6.inc file in the project window.
;
; 2. Fill in the missing source code in the subroutine -
;    named "_Copy_PM_String" for LAB5_PART2. Refer to Copy_PM_String.s file
;    in project window.
;
; 4. Program the device using ICD2. Reset and Run
;    You will see "Time and Tide" displayed on line 3 of the LCD
;
; 5. Press switch S1
;    What do you see on Line 3 of the LCD?
;
;..............................................................................
;END_HEADER

                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab5.inc"             ;Lab-specific global equates

                                        ;Config Macros to program configuration
                                        ;words
                                        ;More example macros are provided in
                                        ;the device include file, p30f6014.inc
        config __FOSC, CSW_FSCM_OFF & XT_PLL8
        config __FWDT, WDT_OFF
        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_OFF & MCLR_EN
        config __FGS, CODE_PROT_OFF


        .global MyConstString, MyVarString

        .section .data
MyVarString:    .asciz "Time and Tide"

        .section .myconst, "r"
MyConstString:  .asciz "Northern Star"


        .global _main                   ;Provide global scope to routine
        .section .text                  ;Places source code in Code section


_main:                                  ;C-run-time library brings you here



        bclr INTCON1, #NSTDIS           ;Enable Nested Interrupts


        rcall   _SPI2_init              ;"Relative" Call to SPI2
                                        ;initialaization routine

        rcall   _LCD_Controller_init    ;"Relative" Call to PIC18F242
                                        ;initialization routine


        bset    TRISA, #TRISA12         ;Configure RA12 as input

S1SwitchPress:
        btsc    PORTA, #RA12            ;Has S1 been pressed?
        bra     S1SwitchPress           ;Wait until S1 is pressed

        ;INSERT PART 1 CODE HERE        ;Call function "_Copy_PM_String"

        rcall   _DisplayLCD


done:   nop
        nop
        bra     done                    ;Loop endlessly to "done"





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.end                            ;EOF
